﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.ComponentModel.DataAnnotations;
using Infragistics.Web.Mvc;

namespace igGridComboEditor.Models
{
	public class GridModel2
	{
		public GridModel2()
		{
		}
		#region Grid1
		private GridModel _grid1 = null;
		public GridModel Grid1
		{
			get
			{
				if (this._grid1 == null)
				{
					this._grid1 = new GridModel();
					this._grid1.Height = "300px";
					this._grid1.Columns.Add(new GridColumn("ID", "ID", "number", "100px"));
					this._grid1.Columns.Add(new GridColumn("Product", "Product", "number", "100px", "productFormatter"));
					this._grid1.Columns.Add(new GridColumn("ProductSlave", "ProductSlave", "number", "100px", "slaveFormatter"));

					List<MyGridRow> data = new List<MyGridRow>();
					data.Add(new MyGridRow(0, 1, 3));
					data.Add(new MyGridRow(1, 1, 5));
					data.Add(new MyGridRow(2, 0, 1));
					data.Add(new MyGridRow(3, 3, 8));
					this._grid1.DataSource = data.AsQueryable();

					var updating = new GridUpdating();
					//updating.ColumnSettings.Add(new ColumnUpdatingSetting() { ColumnKey = "Title", ReadOnly = true });
					
					List<ProductRow> productData = new List<ProductRow>();
					productData.Add(new ProductRow(0, "Car"));
					productData.Add(new ProductRow(1, "Boat"));
					productData.Add(new ProductRow(2, "Jet"));
					productData.Add(new ProductRow(3, "Train"));

					List<ProductSlaveRow> slaveData = new List<ProductSlaveRow>();
					slaveData.Add(new ProductSlaveRow(0, "Red Car"));
					slaveData.Add(new ProductSlaveRow(1, "Blue Car"));
					slaveData.Add(new ProductSlaveRow(2, "Small Car"));
					slaveData.Add(new ProductSlaveRow(3, "Big Car"));
					slaveData.Add(new ProductSlaveRow(4, "Red Boat"));
					slaveData.Add(new ProductSlaveRow(5, "Big Boat"));
					slaveData.Add(new ProductSlaveRow(6, "Fighter Jet"));
					slaveData.Add(new ProductSlaveRow(7, "Black Jet"));
					slaveData.Add(new ProductSlaveRow(8, "Red Train"));
					slaveData.Add(new ProductSlaveRow(9, "Pink Train"));
					slaveData.Add(new ProductSlaveRow(10, "Old Train"));
					slaveData.Add(new ProductSlaveRow(11, "White Train"));

					updating.ColumnSettings.Add(new ColumnUpdatingSetting()
					{
						ColumnKey = "Product",
						EditorType = ColumnEditorType.Combo,
						ComboEditorOptions = new ColumnUpdatingComboEditorOptions()
						{
							DataSource = productData,
							ValueKey = "ProductKey",
							TextKey = "Name"
						}
					});
					updating.ColumnSettings.Add(new ColumnUpdatingSetting() {
						ColumnKey = "ProductSlave",
						EditorType = ColumnEditorType.Combo,
						ComboEditorOptions = new ColumnUpdatingComboEditorOptions() {
							DataSource = slaveData,
							ValueKey = "SlaveKey",
							TextKey = "Name"
						}
					});

					this._grid1.Features.Add(updating);

				}
				return this._grid1;
			}
			set
			{
				_grid1 = value;
			}
		}
		#endregion
	}
	#region MyGridRow
	public class MyGridRow
	{
		public int ID { get; set; }
		public int Product { get; set; }
		public int ProductSlave { get; set; }
		public MyGridRow(int id, int product, int productSlave)
		{
			this.ID = id;
			this.Product = product;
			this.ProductSlave = productSlave;
		}
	}
	#endregion

	#region ProductRow
	public class ProductRow
	{
		public int ProductKey { get; set; }
		public string Name { get; set; }
		public ProductRow(int key, string name)
		{
			this.ProductKey = key;
			this.Name = name;
		}
	}
	#endregion

	#region ProductSlaveRow
	public class ProductSlaveRow
	{
		public int SlaveKey { get; set; }
		public string Name { get; set; }
		public ProductSlaveRow(int key, string name)
		{
			this.SlaveKey = key;
			this.Name = name;
		}
	}
	#endregion
}